Package org.apache.commons.collections4.bidimap

# Class TreeBidiMap<K extends Comparable<K>,V extends Comparable<V>>

java.lang.Object
org.apache.commons.collections4.bidimap.TreeBidiMap<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Serializable`, `Map<K,V>`, `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `OrderedBidiMap<K,V>`, `OrderedMap<K,V>`, `Put<K,V>`

public class TreeBidiMap<K extends Comparable<K>,V extends Comparable<V>> extends Object implements OrderedBidiMap<K,V>, Serializable
Red-Black tree-based implementation of BidiMap where all objects added implement the `Comparable` interface.

This class guarantees that the map will be in both ascending key order and ascending value order, sorted according to the natural order for the key's and value's classes.

This Map is intended for applications that need to be able to look up a key-value pairing by either key or value, and need to do so with equal efficiency.

While that goal could be accomplished by taking a pair of TreeMaps and redirecting requests to the appropriate TreeMap (e.g., containsKey would be directed to the TreeMap that maps values to keys, containsValue would be directed to the TreeMap that maps keys to values), there are problems with that implementation. If the data contained in the TreeMaps is large, the cost of redundant storage becomes significant. The `DualTreeBidiMap` and `DualHashBidiMap` implementations use this approach.

This solution keeps minimizes the data storage by holding data only once. The red-black algorithm is based on `TreeMap`, but has been modified to simultaneously map a tree node by key and by value. This doubles the cost of put operations (but so does using two TreeMaps), and nearly doubles the cost of remove operations (there is a savings in that the lookup of the node to be removed only has to be performed once). And since only one node contains the key and value, storage is significantly less than that required by two TreeMaps.

The Map.Entry instances returned by the appropriate methods will not allow setValue() and will throw an UnsupportedOperationException on attempts to call that method.

Since:
  3.0 (previously DoubleOrderedMap v2.0)
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TreeBidiMap()`
  Constructs a new empty TreeBidiMap.
  `TreeBidiMap(Map<? extends K,? extends V> map)`
  Constructs a new TreeBidiMap by copying an existing Map.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Removes all mappings from this map.
  `boolean`
  `containsKey(Object key)`
  Checks whether this map contains a mapping for the specified key.
  `boolean`
  `containsValue(Object value)`
  Checks whether this map contains a mapping for the specified value.
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a set view of the entries contained in this map in key order.
  `boolean`
  `equals(Object obj)`
  Compares for equals as per the API.
  `K`
  `firstKey()`
  Gets the first (lowest) key currently in this map.
  `V`
  `get(Object key)`
  Gets the value to which this map maps the specified key.
  `K`
  `getKey(Object value)`
  Returns the key to which this map maps the specified value.
  `int`
  `hashCode()`
  Gets the hash code value for this map as per the API.
  `OrderedBidiMap<V,K>`
  `inverseBidiMap()`
  Gets the inverse map for comparison.
  `boolean`
  `isEmpty()`
  Checks whether the map is empty or not.
  `Set<K>`
  `keySet()`
  Returns a set view of the keys contained in this map in key order.
  `K`
  `lastKey()`
  Gets the last (highest) key currently in this map.
  `OrderedMapIterator<K,V>`
  `mapIterator()`
  Obtains a `MapIterator` over the map.
  `K`
  `nextKey(K key)`
  Gets the next key after the one specified.
  `K`
  `previousKey(K key)`
  Gets the previous key before the one specified.
  `V`
  `put(K key, V value)`
  Puts the key-value pair into the map, replacing any previous pair.
  `void`
  `putAll(Map<? extends K,? extends V> map)`
  Puts all the mappings from the specified map into this map.
  `V`
  `remove(Object key)`
  Removes the mapping for this key from this map if present.
  `K`
  `removeValue(Object value)`
  Removes the mapping for this value from this map if present.
  `int`
  `size()`
  Returns the number of key-value mappings in this map.
  `String`
  `toString()`
  Returns a string version of this Map in standard format.
  `Set<V>`
  `values()`
  Returns a set view of the values contained in this map in key order.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- ## Constructor Details

  - ### TreeBidiMap

    public TreeBidiMap()
    Constructs a new empty TreeBidiMap.

  - ### TreeBidiMap

    public TreeBidiMap(Map<? extends K,? extends V> map)
    Constructs a new TreeBidiMap by copying an existing Map.
    Parameters:
      `map` - the map to copy
    Throws:
      `ClassCastException` - if the keys/values in the map are not Comparable or are not mutually comparable
      `NullPointerException` - if any key or value in the map is null

- ## Method Details

  - ### clear

    public void clear()
    Removes all mappings from this map.
    Specified by:
      `clear` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `clear` in interface `Put<K extends Comparable<K>,V extends Comparable<V>>`
    See Also:
      - `Map.clear()`

  - ### containsKey

    public boolean containsKey(Object key)
    Checks whether this map contains a mapping for the specified key.

    The key must implement `Comparable`.

    Specified by:
      `containsKey` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `containsKey` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - key whose presence in this map is to be tested
    Returns:
      true if this map contains a mapping for the specified key
    Throws:
      `ClassCastException` - if the key is of an inappropriate type
      `NullPointerException` - if the key is null
    See Also:
      - `Map.containsKey(Object)`

  - ### containsValue

    public boolean containsValue(Object value)
    Checks whether this map contains a mapping for the specified value.

    The value must implement `Comparable`.

    Specified by:
      `containsValue` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `containsValue` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `value` - value whose presence in this map is to be tested
    Returns:
      true if this map contains a mapping for the specified value
    Throws:
      `ClassCastException` - if the value is of an inappropriate type
      `NullPointerException` - if the value is null
    See Also:
      - `Map.containsValue(Object)`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Returns a set view of the entries contained in this map in key order. For simple iteration through the map, the MapIterator is quicker.

    The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined.

    The set supports element removal, which removes the corresponding mapping from the map. It does not support the add or addAll operations. The returned MapEntry objects do not support setValue.

    Specified by:
      `entrySet` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `entrySet` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      a set view of the values contained in this map.
    See Also:
      - `Map.entrySet()`

  - ### equals

    public boolean equals(Object obj)
    Compares for equals as per the API.
    Specified by:
      `equals` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Overrides:
      `equals` in class `Object`
    Parameters:
      `obj` - the object to compare to
    Returns:
      true if equal

  - ### firstKey

    public K firstKey()
    Gets the first (lowest) key currently in this map.
    Specified by:
      `firstKey` in interface `OrderedMap<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      the first (lowest) key currently in this sorted map
    Throws:
      `NoSuchElementException` - if this map is empty

  - ### get

    public V get(Object key)
    Gets the value to which this map maps the specified key. Returns null if the map contains no mapping for this key.

    The key must implement `Comparable`.

    Specified by:
      `get` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `get` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - key whose associated value is to be returned
    Returns:
      the value to which this map maps the specified key, or null if the map contains no mapping for this key
    Throws:
      `ClassCastException` - if the key is of an inappropriate type
      `NullPointerException` - if the key is null
    See Also:
      - `Map.get(Object)`

  - ### getKey

    public K getKey(Object value)
    Returns the key to which this map maps the specified value. Returns null if the map contains no mapping for this value.

    The value must implement `Comparable`.

    Specified by:
      `getKey` in interface `BidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `value` - value whose associated key is to be returned.
    Returns:
      the key to which this map maps the specified value, or null if the map contains no mapping for this value.
    Throws:
      `ClassCastException` - if the value is of an inappropriate type
      `NullPointerException` - if the value is null

  - ### hashCode

    public int hashCode()
    Gets the hash code value for this map as per the API.
    Specified by:
      `hashCode` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Overrides:
      `hashCode` in class `Object`
    Returns:
      the hash code value for this map

  - ### inverseBidiMap

    public OrderedBidiMap<V,K> inverseBidiMap()
    Gets the inverse map for comparison.
    Specified by:
      `inverseBidiMap` in interface `BidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `inverseBidiMap` in interface `OrderedBidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      the inverse map

  - ### isEmpty

    public boolean isEmpty()
    Checks whether the map is empty or not.
    Specified by:
      `isEmpty` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `isEmpty` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      true if the map is empty
    See Also:
      - `Map.isEmpty()`

  - ### keySet

    public Set<K> keySet()
    Returns a set view of the keys contained in this map in key order.

    The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined.

    The set supports element removal, which removes the corresponding mapping from the map. It does not support the add or addAll operations.

    Specified by:
      `keySet` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `keySet` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      a set view of the keys contained in this map.
    See Also:
      - `Map.keySet()`

  - ### lastKey

    public K lastKey()
    Gets the last (highest) key currently in this map.
    Specified by:
      `lastKey` in interface `OrderedMap<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      the last (highest) key currently in this sorted map
    Throws:
      `NoSuchElementException` - if this map is empty

  - ### mapIterator

    public OrderedMapIterator<K,V> mapIterator()
    Description copied from interface: `IterableGet`
    Obtains a `MapIterator` over the map.

    A map iterator is an efficient way of iterating over maps. There is no need to access the entry set or use Map Entry objects.

         IterableMap<String,Integer> map = new HashedMap<String,Integer>();
         MapIterator<String,Integer> it = map.mapIterator();
         while (it.hasNext()) {
           String key = it.next();
           Integer value = it.getValue();
           it.setValue(value + 1);
         }

    Specified by:
      `mapIterator` in interface `IterableGet<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `mapIterator` in interface `OrderedMap<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      a map iterator

  - ### nextKey

    public K nextKey(K key)
    Gets the next key after the one specified.

    The key must implement `Comparable`.

    Specified by:
      `nextKey` in interface `OrderedMap<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - the key to search for next from
    Returns:
      the next key, null if no match or at end

  - ### previousKey

    public K previousKey(K key)
    Gets the previous key before the one specified.

    The key must implement `Comparable`.

    Specified by:
      `previousKey` in interface `OrderedMap<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - the key to search for previous from
    Returns:
      the previous key, null if no match or at start

  - ### put

    public V put(K key, V value)
    Puts the key-value pair into the map, replacing any previous pair.

    When adding a key-value pair, the value may already exist in the map against a different key. That mapping is removed, to ensure that the value only occurs once in the inverse map.

          BidiMap map1 = new TreeBidiMap();
          map.put("A","B");  // contains A mapped to B, as per Map
          map.put("A","C");  // contains A mapped to C, as per Map

          BidiMap map2 = new TreeBidiMap();
          map.put("A","B");  // contains A mapped to B, as per Map
          map.put("C","B");  // contains C mapped to B, key A is removed

    Both key and value must implement `Comparable`.

    Specified by:
      `put` in interface `BidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `put` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `put` in interface `Put<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - key with which the specified value is to be associated
      `value` - value to be associated with the specified key
    Returns:
      the previous value for the key
    Throws:
      `ClassCastException` - if the key is of an inappropriate type
      `NullPointerException` - if the key is null
    See Also:
      - `Map.put(Object, Object)`

  - ### putAll

    public void putAll(Map<? extends K,? extends V> map)
    Puts all the mappings from the specified map into this map.

    All keys and values must implement `Comparable`.

    Specified by:
      `putAll` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `putAll` in interface `Put<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `map` - the map to copy from
    See Also:
      - `Map.putAll(Map)`

  - ### remove

    public V remove(Object key)
    Removes the mapping for this key from this map if present.

    The key must implement `Comparable`.

    Specified by:
      `remove` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `remove` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `key` - key whose mapping is to be removed from the map.
    Returns:
      previous value associated with specified key, or null if there was no mapping for key.
    Throws:
      `ClassCastException` - if the key is of an inappropriate type
      `NullPointerException` - if the key is null
    See Also:
      - `Map.remove(Object)`

  - ### removeValue

    public K removeValue(Object value)
    Removes the mapping for this value from this map if present.

    The value must implement `Comparable`.

    Specified by:
      `removeValue` in interface `BidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Parameters:
      `value` - value whose mapping is to be removed from the map
    Returns:
      previous key associated with specified value, or null if there was no mapping for value.
    Throws:
      `ClassCastException` - if the value is of an inappropriate type
      `NullPointerException` - if the value is null

  - ### size

    public int size()
    Returns the number of key-value mappings in this map.
    Specified by:
      `size` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `size` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      the number of key-value mappings in this map
    See Also:
      - `Map.size()`

  - ### toString

    public String toString()
    Returns a string version of this Map in standard format.
    Overrides:
      `toString` in class `Object`
    Returns:
      a standard format string version of the map

  - ### values

    public Set<V> values()
    Returns a set view of the values contained in this map in key order. The returned object can be cast to a Set.

    The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined.

    The set supports element removal, which removes the corresponding mapping from the map. It does not support the add or addAll operations.

    Specified by:
      `values` in interface `BidiMap<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `values` in interface `Get<K extends Comparable<K>,V extends Comparable<V>>`
    Specified by:
      `values` in interface `Map<K extends Comparable<K>,V extends Comparable<V>>`
    Returns:
      a set view of the values contained in this map.
    See Also:
      - `Map.values()`